;**********************************************************************
display_pattern_id
;**********************************************************************

    var          tens
    var          ones
    var          dpif_count ; ones

;   clear the display
;   clear all the inxx vars (32 of themn)

    movlw        LOW in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H


    movlw        0x20
    movwf        dpif_count

    movlw        0x00
dpid_loop1
    movwi        FSR0++

    decfsz       dpif_count,f
    goto         dpid_loop1


    clrf         tens
    incf         pattern,w      ; W = pattern + 1
    movwf        ones

;
; split pattern into tens and ones digits.
;
dpid_loop2
    movlw        0x0a           ; less then 10?
    subwf        ones,w
    btfss        STATUS,C
    goto         dpid2
    
    movlw        0x0a 
    subwf        ones,f
    incf         tens,f
    goto         dpid_loop2
;
;   add 10 to ones and tens for digit placement in char table
dpid2
    movlw        0x10
    addwf        ones,f
    addwf        tens,f  

    btfss        demo_mode,0
    goto         dpid3
;
;   print out "D" for demo
;
    movlw        LOW in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H

    movlw        0x24  ; (D - 0x20)
    call display_char

dpid3
;
;   print tens digit
;
    movlw        LOW in6
    movwf        FSR0L
    movlw        HIGH in6
    movwf        FSR0H

    movfw        tens
    call display_char

;
;   print ones digit
;

    moviw        FSR0++

    movfw        ones 
    call display_char
;
;  display it
;


   movlw        0xff
   call         display_1bit
   movlw        0xff
   call         display_1bit

    return


;**********************************************************************
display_char
;**********************************************************************
;
; FSR0 = location
; w = char to display
;
  var offset_low
  var offset_hi
; char_in     b2l_out_hi
; char_words  b2l_in_red
; tentry      b2l_lcount

   var save_fsr1h
   var save_fsr1l

   movwf        char_in

;  save fsr1
   movfw        FSR1H     
   movwf        save_fsr1h 
   movfw        FSR1L
   movwf        save_fsr1l

; offset = chartabel
   movlw        LOW chartable     
   movwf        offset_low 
   movlw        HIGH chartable
   movwf        offset_hi

; offset = offset + char_in <<1
   movf         char_in,w
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in,w           
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f   

; char_in << 2 ; if carry offset_hi++         
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in, f
   rlf          char_in, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f

; offset = offset + char_in
   movf         char_in,w           ; offset = offset + char_in
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f     

;  FSR1 = offset
   movfw        offset_hi
   movwf        FSR1H
   movfw        offset_low
   movwf        FSR1L

   moviw        FSR1++
   movwf        char_words

dc_looper

   moviw        FSR1++    ; char table
   movwi        FSR0++    ; display buffer

   decfsz       char_words,f
   goto         dc_looper

;  restore fsr1
   movfw        save_fsr1h     
   movwf        FSR1H 
   movfw        save_fsr1l
   movwf        FSR1L

   return
