;**********************************************************************
;   Copyright (C) 2012 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
table_type_35
;**********************************************************************
;
;
;   get the char
;   lookup char line count
;   loop char count
;      shift_left
;      load char line
;      display
;   endloop
;

    var char_in
    var char_color
    var tentry
    var char_words

   var save_fsr1h
   var save_fsr1l
   var offset_low
   var offset_hi

;
;  offset = chartabel + (char_in - 0x20) * 6 + char_offset
;  offset = chartabel + (char_in - 0x20) + ((char_in - 0x21) * 4) + char_offset <<1
;  offset = chartabel + (char_in - 0x20) + ((char_in - 0x21) <<2) + char_offset <<1
;  12 bit            12 bit      7 bit              9 bit                    4 bit

   call         get_next_pattern_entry

   movwf        char_in

;  save fsr1
   movfw        FSR1H     
   movwf        save_fsr1h 
   movfw        FSR1L
   movwf        save_fsr1l

   movf         char_in,f         ; test for zero

   movlw        0x20              ; color code?
   subwf        char_in,w
   
   btfsc        STATUS,C
   goto         skipt3

   movf         char_in,w         ; get color, then pull next entry
   movwf        char_color
   goto         p25_return

skipt3
; char_in = char_in - 0x20
   movlw        0x20              
   subwf        char_in,f        

; offset = chartabel
   movlw        LOW chartable     
   movwf        offset_low 
   movlw        HIGH chartable
   movwf        offset_hi

; offset = offset + char_in <<1
   movf         char_in,w
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in,w           
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f   

; char_in << 2 ; if carry offset_hi++         
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in, f
   rlf          char_in, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f 

; offset = offset + char_in
   movf         char_in,w           ; offset = offset + char_in
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f     

;  FSR1 = offset
   movfw        offset_hi
   movwf        FSR1H
   movfw        offset_low
   movwf        FSR1L

   moviw        FSR1++
   movwf        char_words


p25_looper

   moviw        FSR1++    ; char table
   movwf        tentry

; -------------------
    call shift_left       

    movf  tentry, w
    movwf in8

    movf  tentry, w
    movwf in9

   btfss        char_color,0     ; color adjust
   clrf         in8

   btfss        char_color,2
   clrf         in9

   btfsc        char_color,1     ; color adjust
   comf         in8,f

   btfsc        char_color,3
   comf         in9,f
   
; ------------------

   movfw        pspeed           ; display
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit

   decfsz       char_words,f
   goto         p25_looper

;  add a blank line after the char and display (spacing)    
   call shift_left
   clrf         in8
   clrf         in9

   btfsc        char_color,1     ; color adjust
   comf         in8,f

   btfsc        char_color,3
   comf         in9,f
;--

   movfw        pspeed           ; display
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit

p25_return

;  restore fsr1
   movfw        save_fsr1h    
   movwf        FSR1H  
   movfw        save_fsr1l
   movwf        FSR1L

   return
